Imports System.ComponentModel
Imports System.Text
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Shapes
Imports System.Collections.ObjectModel
Imports EventPhone001.ServiceReference1

Namespace EventPhone001
	Public Class MainViewModel
		Implements INotifyPropertyChanged

		Public _sc As Service1Client

		Public Sub _sc_CheckInCompleted(ByVal sender As Object, ByVal e As CheckInCompletedEventArgs)
		End Sub

		Public Sub _sc_MyDataCompleted(ByVal sender As Object, ByVal e As MyDataCompletedEventArgs)
			For i  = 0 To e.Result.Count - 2
				Dim ss As String = e.Result(i).ToString
				Dim s1 As String = ss.Substring(0, ss.IndexOf("("c) - 1)
				Dim s2 As String = ss.Substring(s1.Length + 2, ss.IndexOf(")"c)-s1.Length-2)
				Dim s3 As String = ss.Substring(ss.IndexOf(":"c) + 2)

				'string lname = ss.Substring(0, ss.IndexOf(','));
				'string fname = ss.Substring(lname.Length + 2, ss.IndexOf('(') - lname.Length - 2).TrimEnd;

   '             _sc.CheckInAsync(lname, fname)
					Me.Items.Add(New ItemViewModel With {.LineOne=s1, .LineTwo=s3, .LineThree=s2})
			Next i

			Me.IsDataLoaded = True
		End Sub

		Public Sub New()
			Me.Items = New ObservableCollection(Of ItemViewModel)
			_sc = New Service1Client
			AddHandler _sc.MyDataCompleted, AddressOf _sc_MyDataCompleted
			AddHandler _sc.CheckInCompleted, AddressOf _sc_CheckInCompleted
			_sc.MyDataAsync(1)
		End Sub

		''' <summary>
		''' A collection for ItemViewModel objects.
		''' </summary>
        Private _items As ObservableCollection(Of ItemViewModel)
        Public Property Items As ObservableCollection(Of ItemViewModel)
            Get
                Return _items
            End Get
            Private Set(ByVal value As ObservableCollection(Of ItemViewModel))
                _items = value
            End Set
        End Property

		Private _sampleProperty As String = "Sample Runtime Property Value"
		''' <summary>
		''' Sample ViewModel property; this property is used in the view to display its value using a Binding
		''' </summary>
		''' <returns></returns>
		Public Property SampleProperty As String
			Get
				Return _sampleProperty
			End Get
			Set(ByVal value As String)
				If value <> _sampleProperty Then
					_sampleProperty = value
					NotifyPropertyChanged("SampleProperty")
				End If
			End Set
		End Property

        Private _isDataLoaded As Boolean
        Public Property IsDataLoaded As Boolean
            Get
                Return _isDataLoaded
            End Get
            Private Set(ByVal value As Boolean)
                _isDataLoaded = value
            End Set
        End Property

		''' <summary>
		''' Creates and adds a few ItemViewModel objects into the Items collection.
		''' </summary>
		Public Sub LoadData()
			' Sample data; replace with real data
'            
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime one", LineTwo = "Maecenas praesent accumsan bibendum", LineThree = "Facilisi faucibus habitant inceptos interdum lobortis nascetur pharetra placerat pulvinar sagittis senectus sociosqu" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime two", LineTwo = "Dictumst eleifend facilisi faucibus", LineThree = "Suscipit torquent ultrices vehicula volutpat maecenas praesent accumsan bibendum dictumst eleifend facilisi faucibus" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime three", LineTwo = "Habitant inceptos interdum lobortis", LineThree = "Habitant inceptos interdum lobortis nascetur pharetra placerat pulvinar sagittis senectus sociosqu suscipit torquent" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime four", LineTwo = "Nascetur pharetra placerat pulvinar", LineThree = "Ultrices vehicula volutpat maecenas praesent accumsan bibendum dictumst eleifend facilisi faucibus habitant inceptos" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime five", LineTwo = "Maecenas praesent accumsan bibendum", LineThree = "Maecenas praesent accumsan bibendum dictumst eleifend facilisi faucibus habitant inceptos interdum lobortis nascetur" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime six", LineTwo = "Dictumst eleifend facilisi faucibus", LineThree = "Pharetra placerat pulvinar sagittis senectus sociosqu suscipit torquent ultrices vehicula volutpat maecenas praesent" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime seven", LineTwo = "Habitant inceptos interdum lobortis", LineThree = "Accumsan bibendum dictumst eleifend facilisi faucibus habitant inceptos interdum lobortis nascetur pharetra placerat" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime eight", LineTwo = "Nascetur pharetra placerat pulvinar", LineThree = "Pulvinar sagittis senectus sociosqu suscipit torquent ultrices vehicula volutpat maecenas praesent accumsan bibendum" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime nine", LineTwo = "Maecenas praesent accumsan bibendum", LineThree = "Facilisi faucibus habitant inceptos interdum lobortis nascetur pharetra placerat pulvinar sagittis senectus sociosqu" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime ten", LineTwo = "Dictumst eleifend facilisi faucibus", LineThree = "Suscipit torquent ultrices vehicula volutpat maecenas praesent accumsan bibendum dictumst eleifend facilisi faucibus" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime eleven", LineTwo = "Habitant inceptos interdum lobortis", LineThree = "Habitant inceptos interdum lobortis nascetur pharetra placerat pulvinar sagittis senectus sociosqu suscipit torquent" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime twelve", LineTwo = "Nascetur pharetra placerat pulvinar", LineThree = "Ultrices vehicula volutpat maecenas praesent accumsan bibendum dictumst eleifend facilisi faucibus habitant inceptos" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime thirteen", LineTwo = "Maecenas praesent accumsan bibendum", LineThree = "Maecenas praesent accumsan bibendum dictumst eleifend facilisi faucibus habitant inceptos interdum lobortis nascetur" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime fourteen", LineTwo = "Dictumst eleifend facilisi faucibus", LineThree = "Pharetra placerat pulvinar sagittis senectus sociosqu suscipit torquent ultrices vehicula volutpat maecenas praesent" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime fifteen", LineTwo = "Habitant inceptos interdum lobortis", LineThree = "Accumsan bibendum dictumst eleifend facilisi faucibus habitant inceptos interdum lobortis nascetur pharetra placerat" });
'            this.Items.Add(new ItemViewModel() { LineOne = "runtime sixteen", LineTwo = "Nascetur pharetra placerat pulvinar", LineThree = "Pulvinar sagittis senectus sociosqu suscipit torquent ultrices vehicula volutpat maecenas praesent accumsan bibendum" });
'            
		End Sub

		Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

		Private Sub NotifyPropertyChanged(ByVal propertyName As String)
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
		End Sub
	End Class
End Namespace
