Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports EventPhone001.ServiceReference1

Namespace EventPhone001
	Partial Public Class DetailsPage
		Inherits PhoneApplicationPage

		Public _sc As Service1Client
		Private fname As String
		Private lname As String

		' Constructor
		Public Sub New()
			InitializeComponent()
			_sc = New Service1Client
			AddHandler _sc.ToggleRegisterCompleted, AddressOf _sc_ToggleRegisterCompleted
			AddHandler _sc.CheckInCompleted, AddressOf _sc_CheckInCompleted
		End Sub

		' When page is navigated to set data context to selected item in list
		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
			Dim selectedIndex As String = ""
			If NavigationContext.QueryString.TryGetValue("selectedItem", selectedIndex) Then
				Dim index As Integer = Integer.Parse(selectedIndex)
				DataContext = App.ViewModel.Items(index)
			End If
		End Sub

		Private Sub ContentText_Tap(ByVal sender As Object, ByVal e As GestureEventArgs)
		End Sub

		Private Sub ContentText_DoubleTap(ByVal sender As Object, ByVal e As GestureEventArgs)
		End Sub

		Public Sub _sc_ToggleRegisterCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.AsyncCompletedEventArgs)
			_sc.CheckInAsync(lname,fname)
			'MessageBox.Show("Checkin Status Changed");
		End Sub

		Public Function BrushFromColorName(ByVal colorName As String) As SolidColorBrush
			Dim s As String
			s = "<SolidColorBrush xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation'"
			s &= " Color='" & colorName & "'/>"

			Return TryCast(System.Windows.Markup.XamlReader.Load(s), SolidColorBrush)
		End Function

		Public Sub _sc_CheckInCompleted(ByVal sender As Object, ByVal e As CheckInCompletedEventArgs)
			If e.Result.ToString = "True" Then
				ListTitle.Foreground = BrushFromColorName("Green")
				MessageBox.Show("Checked IN")
			Else
				ListTitle.Foreground = BrushFromColorName("Red")
				MessageBox.Show("Checked OUT")
			End If
		End Sub

		Private Sub ListTitle_DoubleTap(ByVal sender As Object, ByVal e As GestureEventArgs)
			checkmein()
		End Sub

		Private Sub ApplicationBarMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
			checkmein()
		End Sub

		Private Sub ApplicationBarIconButton_Click(ByVal sender As Object, ByVal e As EventArgs)
			checkmein()
		End Sub

		Private Sub checkmein()
			Dim ss As String = ListTitle.Text
			lname = ss.Substring(0, ss.IndexOf(","c))
			fname = ss.Substring(lname.Length + 2).TrimEnd
			_sc.ToggleRegisterAsync(lname, fname)
		End Sub

		Private Sub ApplicationBarIconButton_Click_1(ByVal sender As Object, ByVal e As EventArgs)
			'NavigationService.Navigate(new Uri("http://www.facebook.com/groups/405426816152189/", UriKind.Absolute));
			NavigationService.Navigate(New Uri("/Facebook.xaml", UriKind.Relative))
		End Sub

		Private Sub PhoneApplicationPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			'button1.IconUri = new Uri("/Images/YourImage.png", UriKind.Relative);
		End Sub
	End Class
End Namespace
